<?php
namespace Teknisa\CTB\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ctb90100SpedContabilFactory {

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    
    public function callSpedContabilProcedure($params){
        $procedure = new StoredProcedure($this->connection, 'SPED_CONTABIL_MESTRE');
        
        $procedure->addParam(new Param('P_NRSEQARQMAG', Param::PARAM_INPUT, $params["NRSEQARQMAG"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $params["CDEMPRESA"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $params["DTINICIAL"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $params["DTFINAL"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DSNATUREZA', Param::PARAM_INPUT, $params["DSNATUREZA"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDSPED', Param::PARAM_INPUT, $params["IDSPED"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_PORTE', Param::PARAM_INPUT, $params["PORTE"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_GERARAZAO', Param::PARAM_INPUT, $params["GERARAZAO"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TIPOLIVRO', Param::PARAM_INPUT, $params["TIPOLIVRO"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_FINALIDADE', Param::PARAM_INPUT, $params["FINALIDADE"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_PERIODO', Param::PARAM_INPUT, $params["PERIODO"], Param::PARAM_TYPE_STR));
        
        $procedure->execute();
    }
    /*
     * Função para retornar os dados gerados na procedure ......
     */
    public function getSpedContabilData($params) {
        $sql = "SELECT * FROM ARQMAGNETICO 
                WHERE NRSEQARQMAG = :NRSEQARQMAG ORDER BY NRORDREGARQ";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetchAll();
    }
    
}